package apis

type AccessLog struct {
	Id                int64   `json:"id" bson:"-"`
	MerchantId        int64   `json:"-" bson:"merchant_id"`
	ApiId             int64   `json:"-" bson:"api_id"`
	MerchantName      string  `json:"merchant_name" bson:"merchant_name"`
	ApiName           string  `json:"api_name" bson:"api_name"`
	RequestParams     string  `json:"request_params" bson:"request_params"`
	ResponseParams    string  `json:"origin_response" bson:"origin_response"`
	RawRequestParams  string  `json:"origin_request" bson:"origin_request"`
	RawResponseParams string  `json:"response_params" bson:"-"`
	RawCode           int     `json:"raw_code" bson:"raw_code"`
	Code              int     `json:"code" bson:"code"`
	Msg               string  `json:"msg" bson:"-"`
	IsReuse           bool    `json:"is_reuse" bson:""`
	State             bool    `json:"state" bson:""`
	RemoteAddr        string  `json:"remote_addr" bson:""`
	Elapsed           float64 `json:"elapsed" bson:""`
	Timestamp         int64   `json:"timestamp" bson:""`
	ProviderCount     int     `json:"provider_count"`
	UtSource          string  `json:"ut_source"`
	CreateTime        string  `json:"create_time" bson:""`
	Search            string  `json:"search"`
	MerchantDataApiId int64   `json:"merchant_data_api_id"`
}

type TGdAccessLogMonth1 struct {
	AccessLog `json:"access_log"`
}
type TGdAccessLogMonth2 struct {
	AccessLog `json:"access_log"`
}
type TGdAccessLogMonth3 struct {
	AccessLog `json:"access_log"`
}
type TGdAccessLogMonth4 struct {
	AccessLog `json:"access_log"`
}
type TGdAccessLogMonth5 struct {
	AccessLog `json:"access_log"`
}
type TGdAccessLogMonth6 struct {
	AccessLog `json:"access_log"`
}
type TGdAccessLogMonth7 struct {
	AccessLog `json:"access_log"`
}
type TGdAccessLogMonth8 struct {
	AccessLog `json:"access_log"`
}
type TGdAccessLogMonth9 struct {
	AccessLog `json:"access_log"`
}
type TGdAccessLogMonth10 struct {
	AccessLog `json:"access_log"`
}
type TGdAccessLogMonth11 struct {
	AccessLog `json:"access_log"`
}

type TGdAccessLogMonth12 struct {
	AccessLog `json:"access_log"`
}

type AccessLogDay struct {
	AccessLog `json:"access_log"`
}

func (o *TGdAccessLogMonth1) TableName() string {
	return "t_gd_access_log_month1"
}

func (o *TGdAccessLogMonth2) TableName() string {
	return "t_gd_access_log_month2"
}

func (o *TGdAccessLogMonth3) TableName() string {
	return "t_gd_access_log_month3"
}

func (o *TGdAccessLogMonth4) TableName() string {
	return "t_gd_access_log_month4"
}

func (o *TGdAccessLogMonth5) TableName() string {
	return "t_gd_access_log_month5"
}

func (o *TGdAccessLogMonth6) TableName() string {
	return "t_gd_access_log_month6"
}

func (o *TGdAccessLogMonth7) TableName() string {
	return "t_gd_access_log_month7"
}

func (o *TGdAccessLogMonth8) TableName() string {
	return "t_gd_access_log_month8"
}

func (o *TGdAccessLogMonth9) TableName() string {
	return "t_gd_access_log_month9"
}

func (o *TGdAccessLogMonth10) TableName() string {
	return "t_gd_access_log_month10"
}

func (o *TGdAccessLogMonth11) TableName() string {
	return "t_gd_access_log_month11"
}

func (o *TGdAccessLogMonth12) TableName() string {
	return "t_gd_access_log_month12"
}

func (o *TGdThirdpartLogMonth1) TableName() string {
	return "t_gd_thirdpart_log_month1"
}

func (o *TGdThirdpartLogMonth2) TableName() string {
	return "t_gd_thirdpart_log_month2"
}

func (o *TGdThirdpartLogMonth3) TableName() string {
	return "t_gd_thirdpart_log_month3"
}

func (o *TGdThirdpartLogMonth4) TableName() string {
	return "t_gd_thirdpart_log_month4"
}

func (o *TGdThirdpartLogMonth5) TableName() string {
	return "t_gd_thirdpart_log_month5"
}

func (o *TGdThirdpartLogMonth6) TableName() string {
	return "t_gd_thirdpart_log_month6"
}

func (o *TGdThirdpartLogMonth7) TableName() string {
	return "t_gd_thirdpart_log_month7"
}

func (o *TGdThirdpartLogMonth8) TableName() string {
	return "t_gd_thirdpart_log_month8"
}

func (o *TGdThirdpartLogMonth9) TableName() string {
	return "t_gd_thirdpart_log_month9"
}

func (o *TGdThirdpartLogMonth10) TableName() string {
	return "t_gd_thirdpart_log_month10"
}

func (o *TGdThirdpartLogMonth11) TableName() string {
	return "t_gd_thirdpart_log_month11"
}

func (o *TGdThirdpartLogMonth12) TableName() string {
	return "t_gd_thirdpart_log_month12"
}

func (o *AccessLogDay) TableName() string {
	return "t_gd_access_log_day"
}

type ThirdpartLogDay struct {
	ThirdpartLog `json:"thirdpart_log"`
}

func (o *ThirdpartLogDay) TableName() string {
	return "t_gd_thirdpart_log_day"
}

type TGdAccessLogHistory struct {
	AccessLog
}

func (o *TGdAccessLogHistory) TableName() string {
	return "t_gd_access_log_history"
}

func (o *AccessLog) TableName() string {
	return "t_gd_access_log"
}

type InvalidAccessLog struct {
	Id            int64   `json:"id"`
	MerchantId    int64   `json:"-"`
	ApiId         int64   `json:"-"`
	MerchantName  string  `json:"merchant_name"`
	ApiName       string  `json:"api_name"`
	RequestParams string  `json:"request_params"`
	Code          int     `json:"code"`
	Msg           string  `json:"msg"`
	RemoteAddr    string  `json:"remote_addr"`
	Elapsed       float64 `json:"elapsed"`
	Timestamp     int64   `json:"-"`
	CreateTime    string  `json:"create_time"`
}

func (o *InvalidAccessLog) TableName() string {
	return "t_gd_access_log_invalid"
}

type ThirdpartLog struct {
	Id              int64   `json:"id"`
	AccessId        int64   `json:"access_id"`
	MerchantId      int64   `json:"-"`
	ApiId           int64   `json:"-"`
	ProviderId      int64   `json:"-"`
	ProviderApiId   int64   `json:"-"`
	MerchantName    string  `json:"merchant_name"`
	ApiName         string  `json:"api_name"`
	ProviderName    string  `json:"provider_name"`
	ProviderApiName string  `json:"provider_api_name"`
	RequestParams   string  `json:"request_params"`
	ResponseParams  string  `json:"response_params"`
	RawCode         string  `json:"raw_code"`
	Code            int     `json:"code"`
	Msg             string  `json:"msg"`
	State           bool    `json:"state"`
	RemoteAddr      string  `json:"remote_addr"`
	Elapsed         float64 `json:"elapsed"`
	Timestamp       int64   `json:"-"`
	CreateTime      string  `json:"create_time"`
}

type TGdThirdpartAccessLogHistory struct {
	ThirdpartLog
}

type TGdThirdpartLogMonth1 struct {
	ThirdpartLog
}
type TGdThirdpartLogMonth2 struct {
	ThirdpartLog
}
type TGdThirdpartLogMonth3 struct {
	ThirdpartLog
}
type TGdThirdpartLogMonth4 struct {
	ThirdpartLog
}
type TGdThirdpartLogMonth5 struct {
	ThirdpartLog
}
type TGdThirdpartLogMonth6 struct {
	ThirdpartLog
}
type TGdThirdpartLogMonth7 struct {
	ThirdpartLog
}
type TGdThirdpartLogMonth8 struct {
	ThirdpartLog
}
type TGdThirdpartLogMonth9 struct {
	ThirdpartLog
}
type TGdThirdpartLogMonth10 struct {
	ThirdpartLog
}
type TGdThirdpartLogMonth11 struct {
	ThirdpartLog
}
type TGdThirdpartLogMonth12 struct {
	ThirdpartLog
}

func (o *TGdThirdpartAccessLogHistory) TableName() string {
	return "t_gd_thirdpart_access_log_history"
}

func (o *ThirdpartLog) TableName() string {
	return "t_gd_thirdpart_access_log"
}

type AccessLogWrite struct {
	State             bool    `json:"state"`
	Code              int     `json:"code"`
	Msg               string  `json:"msg"`
	RawRequestParams  string  `json:"raw_request_params"`
	RawResponseParams string  `json:"raw_response_params"`
	RequestParams     string  `json:"request_params"`
	ResponseParams    string  `json:"response_params"`
	IsReuse           bool    `json:"is_reuse"`
	UtSource          string  `json:"ut_source"`
	Elapsed           float64 `json:"elapsed"`
}

type ThirdpartLogWrite struct {
	ProviderApiId  int64   `json:"provider_api_id"`
	RequestParams  string  `json:"request_params"`
	ResponseParams string  `json:"response_params"`
	RawCode        string  `json:"raw_code"`
	Code           int     `json:"code"`
	Msg            string  `json:"msg"`
	State          bool    `json:"state"`
	Elapsed        float64 `json:"elapsed"`
}

type LogAddAccessLogReq struct {
	AccessLogWrite
	MerchantId         int64               `json:"merchant_id"`
	ApiId              int64               `json:"api_id"`
	RemoteAddr         string              `json:"remote_addr"`
	TimeStamp          int64               `json:"time_stamp"`
	ThirdpartLogWrites []ThirdpartLogWrite `json:"thirdpart_log_writes"`
	MerchantChildApiId int64               `json:"merchant_child_api_id"`
}

type LogAddAccessLogReply struct {
}

/*type LogAddThirdpartLogReq struct {
	MerchantId     int64   `json:"merchant_id"`
	ApiId          int64   `json:"api_id"`
	ProviderId     int64   `json:"provider_id"`
	ProviderApiId  int64   `json:"provider_api_id"`
	PlateNo        string  `json:"plate_no"`
	PlateType      string  `json:"plate_type"`
	Vin            string  `json:"vin"`
	RequestParams  string  `json:"request_params"`
	ResponseParams string  `json:"response_params"`
	Code           int     `json:"code"`
	Msg            string  `json:"msg"`
	State          bool    `json:"state"`
	RemoteAddr     string  `json:"remote_addr"`
	Elapsed        float64 `json:"elapsed"`
	Timestamp      int64   `json:"timestamp"`
}

type LogAddThirdpartLogReply struct {
}*/

type LogQueryAccessLogReq struct {
	/*Vin            string `json:"vin"`
	PlateNo        string `json:"plate_no"`
	*/
	MerchantId     int64  `json:"merchant_id"`
	ApiId          int64  `json:"api_id"`
	RequestParam   string `json:"request_param"`
	State          int    `json:"state"`
	StartTimestamp int64  `json:"start_timestamp"`
	EndTimestamp   int64  `json:"end_timestamp"`
	PageSize       int64  `json:"page_size"`
	PageNumber     int64  `json:"page_number"`
	Search         string `json:"search"`
	Code           int    `json:"code"`
}

type LogQueryAccessLogReply struct {
	PageSize   int64       `json:"page_size"`
	PageNumber int64       `json:"page_number"`
	Total      int64       `json:"total"`
	AccessLogs []AccessLog `json:"access_logs"`
}

type LogQueryThirdpartAccessLogReq struct {
	/*Vin            string `json:"vin"`
	PlateNo        string `json:"plate_no"`*/
	RequestParam   string `json:"request_param"`
	State          int    `json:"state"`
	ProviderId     int64  `json:"provider_id"`
	ProviderApiId  int64  `json:"provider_api_id"`
	StartTimestamp int64  `json:"start_timestamp"`
	EndTimestamp   int64  `json:"end_timestamp"`
	PageSize       int64  `json:"page_size"`
	PageNumber     int64  `json:"page_number"`
}

type LogQueryThirdpartAccessLogReply struct {
	PageSize      int64          `json:"page_size"`
	PageNumber    int64          `json:"page_number"`
	Total         int64          `json:"total"`
	ThirdpartLogs []ThirdpartLog `json:"thirdpart_logs"`
}

type LogQueryAccessLogCountReq struct {
	MerchantId     int64 `json:"merchant_id"`
	ApiId          int64 `json:"api_id"`
	StartTimestamp int64 `json:"start_timestamp"`
	EndTimestamp   int64 `json:"end_timestamp"`
	PageSize       int64 `json:"page_size"`
	PageNumber     int64 `json:"page_number"`
}

type QueryAccessLogCount struct {
	Date         string  `json:"date"`
	MerchantName string  `json:"merchant_name"`
	ApiName      string  `json:"api_name"`
	Total        int64   `json:"total"`
	Success      int64   `json:"success"`
	Reuse        int64   `json:"reuse"`
	Elapsed      float64 `json:"elapsed"`
	Failed       int64   `json:"failed"`
	SuccessRate  string  `json:"success_rate"`
	ReuseRate    string  `json:"reuse_rate"`
}

type LogQueryAccessLogCountReply struct {
	PageSize             int64                 `json:"page_size"`
	PageNumber           int64                 `json:"page_number"`
	Total                int64                 `json:"total"`
	QueryAccessLogCounts []QueryAccessLogCount `json:"query_access_log_counts"`
}

type QueryThirdpartAccessLogCount struct {
	Date            string  `json:"date"`
	ProviderName    string  `json:"provider_name"`
	ProviderApiName string  `json:"provider_api_name"`
	Total           int64   `json:"total"`
	Success         int64   `json:"success"`
	Elapsed         float64 `json:"elapsed"`
	Failed          int64   `json:"failed"`
	SuccessRate     string  `json:"success_rate"`
}
type LogQueryThirdpartAccessLogCountReq struct {
	ProviderId     int64 `json:"provider_id"`
	ProviderApiId  int64 `json:"provider_api_id"`
	StartTimestamp int64 `json:"start_timestamp"`
	EndTimestamp   int64 `json:"end_timestamp"`
	PageSize       int64 `json:"page_size"`
	PageNumber     int64 `json:"page_number"`
}

type LogQueryThirdpartAccessLogCountReply struct {
	PageSize                      int64                          `json:"page_size"`
	PageNumber                    int64                          `json:"page_number"`
	Total                         int64                          `json:"total"`
	QueryThirdpartAccessLogCounts []QueryThirdpartAccessLogCount `json:"query_thirdpart_access_log_count"`
}

type LogQueryAccessLogThirdpartLogReq struct {
	AccessId  int64 `json:"access_id"`
	Timestamp int64 `json:"timestamp"`
}

type LogQueryAccessLogThirdpartLogReply struct {
	ThirdpartLogs []ThirdpartLog `json:"thirdpart_logs"`
}

type LogAddInvalidAccessLogReq struct {
	MerchantId    int64   `json:"merchant_id"`
	ApiId         int64   `json:"api_id"`
	RemoteAddr    string  `json:"remote_addr"`
	TimeStamp     int64   `json:"time_stamp"`
	Code          int     `json:"code"`
	Msg           string  `json:"msg"`
	RequestParams string  `json:"request_params"`
	Elapsed       float64 `json:"elapsed"`
}

type LogAddInvalidAccessLogReply struct {
}

// 访问接口统计详情
type LogQueryInterfaceCountReq struct {
	ApiId          int64  `json:"api_id"`
	MerchantId     int64  `json:"merchant_id"`
	StartTimestamp int64  `json:"start_timestamp"`
	EndTimestamp   int64  `json:"end_timestamp"`
	Option         int    `json:"option"`
	TabName        string `json:"tab_name"`
	GroupByState   bool   `json:"group_by_state"`
}

type LogQuerySuccessCount struct {
	Reuse   int64 `json:"reuse"`
	Query   int64 `json:"query"`
	UnQuery int64 `json:"un_query"`
}

type LogQueryFailCount struct {
	ProviderFail int64 `json:"provider_fail"`
	ServiceFail  int64 `json:"service_fail"`
}

type LogQueryInvalidCount struct {
	ParamError       int64 `json:"param_error"`
	ParamFormatError int64 `json:"param_format_error"`
}

type LogQueryInterfaceCountReply struct {
	Total                int64   `json:"total"`
	SuccessRate          float64 `json:"success_rate"`
	FailRate             float64 `json:"fail_rate"`
	ReuseRate            float64 `json:"reuse_rate"`
	QueryRate            float64 `json:"query_rate"`
	UnQueryRate          float64 `json:"un_query_rate"`
	ProviderFailRate     float64 `json:"provider_fail_rate"`
	ServiceFailRate      float64 `json:"service_fail_rate"`
	LogQuerySuccessCount LogQuerySuccessCount
	LogQueryFailCount    LogQueryFailCount
	LogQueryInvalidCount LogQueryInvalidCount
}

type LogQueryUserAccessCountReq struct {
	ApiId          int64 `json:"api_id"`
	MerchantId     int64 `json:"merchant_id"`
	StartTimestamp int64 `json:"start_timestamp"`
	EndTimestamp   int64 `json:"end_timestamp"`
	PageSize       int64 `json:"page_size"`
	PageNumber     int64 `json:"page_number"`
}

type LogQueryUserAcessCount struct {
	Date              string  `json:"date"`
	ApiName           string  `json:"api_name"`
	Total             int64   `json:"total"`
	Valid             int64   `json:"valid"`
	Fail              int64   `json:"fail"`
	Query             int64   `json:"query"`
	Reuse             int64   `json:"reuse"`
	MerchantId        int64   `json:"-"`
	ApiId             int64   `json:"-"`
	ValidRate         string  `json:"valid_rate"`
	FailRate          string  `json:"fail_rate"`
	QueryRate         string  `json:"query_rate"`
	ReuseRate         string  `json:"reuse_rate"`
	Elapsed           float64 `json:"elapsed"`
	Charge            int64   `json:"charge"`
	ChargeRate        string  `json:"charge_rate"`
	MerchantDataApiId string  `json:"-"`
}

type LogQueryUserAccessCountReply struct {
	PageSize               int64 `json:"page_size"`
	PageNumber             int64 `json:"page_number"`
	Total                  int64 `json:"total"`
	LogQueryUserAcessCount []LogQueryUserAcessCount
}

type LogQueryThirdpartAccessCountReq struct {
	ProviderApiId  int64  `json:"provider_api_id"`
	Time           string `json:"time"`
	StartTimestamp int64  `json:"start_timestamp"`
	EndTimestamp   int64  `json:"end_timestamp"`
}

type LogQueryThirdpartAccessCountReply struct {
	Total     int64 `json:"total" description:"总用量"`
	UseCount  int64 `json:"use_count" description:"已用量"`
	LeftCount int64 `json:"left_count" description:"剩余用量"`
}

type LogQueryThirdpartInterfaceCountReq struct {
	ProviderApiId  int64 `json:"provider_api_id"`
	StartTimestamp int64 `json:"start_timestamp"`
	EndTimestamp   int64 `json:"end_timestamp"`
	PageSize       int64 `json:"page_size"`
	PageNumber     int64 `json:"page_number"`
}

type LogQueryThirdpartInterfaceCount struct {
	Date            string `json:"date"`
	ProviderApiName string `json:"provider_api_name"`
	ProviderName    string `json:"provider_name"`
	Total           int64  `json:"total"`
	Success         int64  `json:"success"`
	Fail            int64  `json:"fail"`
	Query           int64  `json:"query"`
	UnQuery         int64  `json:"un_query"`
	FailRate        string `json:"fail_rate"`
	QueryRate       string `json:"query_rate"`
}

type LogQueryThirdpartInterfaceCountReply struct {
	PageSize                        int64                             `json:"page_size"`
	PageNumber                      int64                             `json:"page_number"`
	Total                           int64                             `json:"total"`
	LogQueryThirdpartInterfaceCount []LogQueryThirdpartInterfaceCount `json:"log_query_thirdpart_interface_count"`
}

type LogQueryUserAccessCountExportReq struct {
	ApiIdList       []int64 `json:"api_id_list"`
	MerchantId      int64   `json:"merchant_id"`
	StartTimestamp  int64   `json:"start_timestamp"`
	EndTimestamp    int64   `json:"end_timestamp"`
	TimeList        string  `json:"time_list"`
	NeedCount       bool    `json:"need_count"`
	GroupByMerchant bool    `json:"group_by_merchant"`
	TabName         string  `json:"tab_name"`
}

type LogQueryUserAcessCountExport struct {
	Date                  string `json:"date"`
	ApiName               string `json:"api_name"`
	MerchantName          string
	Total                 int64                  `json:"total"`
	Valid                 int64                  `json:"valid"`
	Success               int64                  `json:"success"`
	Query                 int64                  `json:"query"`
	Reuse                 int64                  `json:"reuse"`
	ValidRate             string                 `json:"valid_rate"`
	SuccessRate           string                 `json:"success_rate"`
	QueryRate             string                 `json:"query_rate"`
	ReuseRate             string                 `json:"reuse_rate"`
	AvgElapsed            float64                `json:"avg_elapsed"`
	SumElapsed            float64                `json:"sum_elapsed"`
	PlatformError         int64                  `json:"platform_error"`
	PlatformErrorRate     string                 `json:"platform_error_rate"`
	ProviderError         int64                  `json:"provider_error"`
	ProviderErrorRate     string                 `json:"provider_error_rate"`
	BigElapseds           string                 `json:"big_elapseds"`
	BigElapsedList        []int                  `json:"big_elapsed_list"`
	ChargeBigElapsedList  []int                  `json:"charge_big_elapsed_list"`
	ApiId                 int64                  `json:"api_id"`
	MerchantId            int64                  `json:"merchant_id"`
	Charge                int64                  `json:"charge"`
	ChargeRate            string                 `json:"charge_rate"`
	ChargeReuse           int64                  `json:"charge_reuse"`
	ChargeReuseRate       string                 `json:"charge_reuse_rate"`
	CountInfos            []MerchantApiCountInfo `orm:"-" json:"count_infos"`
	MerchantDataApiId     string                 `json:"-"`
	TimeoutCount          int                    `json:"timeout_count"`
	TimeoutInfo           string                 `json:"timeout_info"`
	NotShow               bool                   `json:"not_show"`
	NonredundantQuery     int                    `json:"nonredundant_query"`
	NonredundantQueryRate string                 `json:"nonredundant_query_rate"`
	Nonredundant          int                    `json:"nonredundant"`
}

type MerchantApiCountInfo struct {
	MerchantDataApiId int64
	ComboType         int
	Count             int
	Used              int
	Remain            int
}
type SourceNameCount struct {
	Name  string `json:"name"`
	Count int    `json:"count"`
	Rate  string `json:"rate"`
}

type SourceExport struct {
	ApiName  string            `json:"api_name"`
	Date     string            `json:"date"`
	Provider string            `json:"provider"`
	Total    int               `json:"total"`
	Sources  []SourceNameCount `json:"sources"`
}

type ErrorCodeCount struct {
	Code  string
	Count int
	Rate  string
}

type ErrorExport struct {
	ApiName string           `json:"api_name"`
	Codes   string           `json:"codes"`
	Total   int              `json:"total"`
	Date    string           `json:"date"`
	Errors  []ErrorCodeCount `json:"errors"`
}

type LogQueryUserAccessCountExportReply struct {
	LogQueryUserAcessCount []LogQueryUserAcessCountExport
	SourceCount            []SourceExport
	ErrorCount             []ErrorExport
}

type TGdAccessLogCountExport struct {
	Id         int64  `json:"id"`
	FileName   string `json:"file_name"`
	Path       string `json:"path"`
	Status     string `json:"status"`
	CreateTime string `json:"create_time"`
	ExportType int    `json:"export_type"`
}

type LogExportCreateReq struct {
	Id         int64  `json:"id"`
	FileName   string `json:"file_name"`
	Path       string `json:"path"`
	Status     string `json:"status"`
	ExportType int    `json:"export_type"`
}

type LogExportCreateReply struct {
	Id int64 `json:"id"`
}

type LogExportListReq struct {
	PageNumber int64 `json:"page_number"`
	IsAll      bool  `json:"is_all"`
	ExportType int   `json:"export_type"`
}

type LogExportListReply struct {
	PageNumber int64                      `json:"page_number"`
	PageSize   int64                      `json:"page_size"`
	Total      int64                      `json:"total"`
	ExportList []TGdAccessLogCountExport `json:"export_list"`
}

type LogExportDeleteReq struct {
	Id        int64  `json:"id"`
	ExportDir string `json:"export_dir"`
}

type LogExportDeleteReply struct {
}

type LogQueryProviderCountExportReq struct {
	ProviderApiIdList  []int64 `json:"provider_api_id_list"`
	ProviderId         int64   `json:"provider_id"`
	StartTimestamp     int64   `json:"start_timestamp"`
	EndTimestamp       int64   `json:"end_timestamp"`
	TimeList           string  `json:"time_list"`
	TabName            string  `json:"tab_name"`
	MerchantId         int64   `json:"merchant_id"`
	ApiId              int64   `json:"api_id"`
	GroupByMerchantApi bool    `json:"group_by_merchant_api"`
	HasMerchantName    bool    `json:"has_merchant_name"`
}

type ProviderApiIdTotal struct {
	ProviderApiId int64
	BigElapseds   string
	Total         int64
}

type LogQueryProviderCountExport struct {
	Date                 string               `json:"date"`
	ProviderApiIdTotals  []ProviderApiIdTotal `json:"provider_api_id_totals"`
	ProviderApiIds       []int64
	ProviderName         string  `json:"provider_name"`
	ProviderApiName      string  `json:"provider_api_name"`
	ProviderApiId        int64   `json:"provider_api_id"`
	Total                int64   `json:"total"`
	Success              int64   `json:"success"`
	Failed               int64   `json:"failed"`
	FailedRate           string  `json:"failed_rate"`
	Query                int64   `json:"query"`
	QueryNoRecord        int64   `json:"query_no_record"`
	QueryNoRecordRate    string  `json:"query_no_record_rate"`
	AvgElapsed           float64 `json:"avg_elapsed"`
	SumElapsed           float64 `json:"sum_elapsed"`
	BigElapseds          string  `json:"big_elapseds"`
	BigElapsedList       []int   `json:"big_elapsed_list"`
	ChargeBigElapsedList []int   `json:"charge_big_elapsed_list"`
	Charge               int64   `json:"charge"`
	ChargeRate           string  `json:"charge_rate"`
	MerchantId           int64   `json:"merchant_id"`
	MerchantName         string  `json:"merchant_name"`
	ApiId                int64   `json:"api_id"`
	ApiName              string  `json:"api_name"`
}

type LogQueryProviderCountExportReply struct {
	LogQueryProviderCount []LogQueryProviderCountExport
}

type LogQueryInterfaceAnalyzeError struct {
	Code  int    `json:"code"`
	Msg   string `json:"msg"`
	Count int    `json:"count"`
	State bool   `json:"state"`
}

type LogQueryInterfaceAnalyzeErrorReply struct {
	List []LogQueryInterfaceAnalyzeError `json:"list"`
}

type LogQueryInterfaceThirdPartyCount struct {
	ProviderName    string `json:"provider_name"`
	ProviderApiName string `json:"provider_api_name"`
	Count           int    `json:"count"`
}

type LogQueryInterfaceThirdPartyCountReply struct {
	List []LogQueryInterfaceThirdPartyCount
}

type ThirdPartyInterfaceErrorAnalyzeReq struct {
	ApiId          int64  `json:"api_id"`
	StartTimestamp int64  `json:"start_timestamp"`
	EndTimestamp   int64  `json:"end_timestamp"`
	TabName        string `json:"tab_name"`
	GroupByState   bool   `json:"group_by_state"`
}

type ThirdPartyInterfaceErrorAnalyze struct {
	Code  string `json:"code"`
	Msg   string `json:"msg"`
	Count int    `json:"count"`
	State bool   `json:"state"`
}

type ThirdPartyInterfaceErrorAnalyzeReply struct {
	List []ThirdPartyInterfaceErrorAnalyze `json:"list"`
}

type LogUpdateApiNameReq struct {
	Type int    `json:"type" description:"0 api name, 1 provider_api_name 2 merchant_name, 3 provider_name"`
	Name string `json:"api_name"`
	Id   int64  `json:"id"`
}

type LogUpdateApiNameReply struct {
}
type LogGenerateReportReq struct {
	Dates              string `json:"dates"`
	ApiReport          bool   `json:"api_report"`
	ProviderReport     bool   `json:"provider_report"`
	BusinessReport     bool   `json:"business_report"`
	MerchantId         int64  `json:"merchant_id"`
	ApiId              int64  `json:"api_id"`
	ProviderApiId      int64  `json:"provider_api_id"`
	MysqlAddr          string `json:"-"`
	MysqlUser          string `json:"-"`
	MysqlPass          string `json:"-"`
	IsInsert           bool   `json:"is_insert"`
	OnlyMail           bool   `json:"only_mail"`
	OnlyReport         bool   `json:"only_report"`
	FileName           string `json:"file_name"`
	ApiWeekStart       string `json:"api_week_start"`
	ProviderWeekStart  string `json:"provider_week_start"`
	BusinessWeekStart  string `json:"business_week_start"`
	ApiMonthStart      string `json:"api_month_start"`
	ProviderMonthStart string `json:"provider_month_start"`
	BusinessMonthStart string `json:"business_month_start"`
}
type LogGenerateReportReply struct {
}

type LogQueryUserAccessBusinessExportReq struct {
	ApiIdList      []int64 `json:"api_id_list"`
	MerchantId     int64   `json:"merchant_id"`
	StartTimestamp int64   `json:"start_timestamp"`
	EndTimestamp   int64   `json:"end_timestamp"`
	TabName        string  `json:"tab_name"`
}

type LogQueryUserAcessBusinessExport struct {
	Date               string `json:"date"`
	ApiName            string `json:"api_name"`
	MerchantName       string
	Total              int    `json:"total"`
	Valid              int    `json:"valid"`
	ValidRate          string `json:"valid_rate"`
	DistinctCount      int    `json:"distinct_count" description:"去重调用量"`
	ApiId              int64  `json:"api_id"`
	MerchantId         int64  `json:"merchant_id"`
	Charge             int    `json:"charge"`
	ChargeRate         string `json:"charge_rate"`
	MerchantDataApiId  string `json:"-"`
	Unvalid            int    `json:"unvalid"`
	UnvalidUnredundant int    `json:"unvalid_unredundant"`
	UnvalidRedundant   int    `json:"unvalid_redundant" description:"无效中的重复调用，即失败-失败里的去重调用"`
	ArgsFormatError    int    `json:"args_format_error"`
	ArgsUnsupport      int    `json:"args_unsupport"`
	ChargeReuse        int    `json:"charge_reuse"`
	ChargeReuseRate    string `json:"charge_reuse_rate"`
	Reuse              int    `json:"reuse"`

	NoRecord            int    `json:"no_record"`
	ProviderError       int    `json:"provider_error"`
	PlatformError       int    `json:"platform_error"`
	TimeoutConf         string `json:"timeout_conf"`
	TimeoutCount        int    `json:"timeout_count"`
	TimeoutRate         string `json:"timeout_rate"`
	FailedUnredundant   int    `json:"failed_unredundant"`
	NorecordUnredundant int    `json:"norecord_unredundant"`
	Success             int    `json:"success"`
}

type LogQueryUserAccessBusinessExportReply struct {
	LogQueryUserAcessBusiness []LogQueryUserAcessBusinessExport
}

type ReciveThirdPartLogReq struct {
	ProviderApiName string  `json:"provider_api_name" bson:"provider_api_name"`
	ProviderName    string  `json:"provider_name" bson:"provider_name"`
	Elapsed         float64 `json:"elapsed" bson:"elapsed"`
	State           int     `json:"state" bson:"state"`
	Code            int     `json:"code" bson:"code"`
	ProviderApiId   int64   `json:"provider_api_id" bson:"provider_api_id"`
	Timestamp       int64   `json:"timestamp" bson:"timestamp"`
}

type ReciveThirdPartLogReply struct{

}

type ReciveAccessLogReq struct {
	ApiName   string  `json:"api_name" bson:"api_name"`
	Elapsed   float64 `json:"elapsed" bson:"elapsed"`
	State     int     `json:"state" bson:"state"`
	Code      int     `json:"code" bson:"code"`
	ApiId     int64   `json:"api_id" bson:"api_id"`
	Timestamp int64   `json:"timestamp" bson:"timestamp"`
}

type ReciveAccessLogReply struct{

}